const H = [
  "left_control",
  "left_shift",
  "left_option",
  "left_command",
  "right_control",
  "right_shift",
  "right_option",
  "right_command",
  "fn"
], se = [
  ...H,
  "caps_lock"
], ae = [
  "return_or_enter",
  "escape",
  "delete_or_backspace",
  "delete_forward",
  "tab",
  "spacebar",
  "hyphen",
  "equal_sign",
  "open_bracket",
  "close_bracket",
  "backslash",
  "non_us_pound",
  "semicolon",
  "quote",
  "grave_accent_and_tilde",
  "comma",
  "period",
  "slash",
  "non_us_backslash"
], le = [
  "up_arrow",
  "down_arrow",
  "left_arrow",
  "right_arrow",
  "page_up",
  "page_down",
  "home",
  "end"
], ue = [
  "a",
  "b",
  "c",
  "d",
  "e",
  "f",
  "g",
  "h",
  "i",
  "j",
  "k",
  "l",
  "m",
  "n",
  "o",
  "p",
  "q",
  "r",
  "s",
  "t",
  "u",
  "v",
  "w",
  "x",
  "y",
  "z"
], ce = [
  "1",
  "2",
  "3",
  "4",
  "5",
  "6",
  "7",
  "8",
  "9",
  "0"
], de = [
  "f1",
  "f2",
  "f3",
  "f4",
  "f5",
  "f6",
  "f7",
  "f8",
  "f9",
  "f10",
  "f11",
  "f12",
  "f13",
  "f14",
  "f15",
  "f16",
  "f17",
  "f18",
  "f19",
  "f20"
], fe = [
  "keypad_num_lock",
  "keypad_slash",
  "keypad_asterisk",
  "keypad_hyphen",
  "keypad_plus",
  "keypad_enter",
  "keypad_1",
  "keypad_2",
  "keypad_3",
  "keypad_4",
  "keypad_5",
  "keypad_6",
  "keypad_7",
  "keypad_8",
  "keypad_9",
  "keypad_0",
  "keypad_period",
  "keypad_equal_sign",
  "keypad_comma"
], he = [
  "print_screen",
  "scroll_lock",
  "pause",
  "insert",
  "application",
  "help",
  "power"
], pe = [
  "international1",
  "international3",
  "lang1",
  "lang2"
], _e = ["japanese_eisuu", "japanese_kana"], me = [
  "volume_down",
  // equal to `volume_decrement`
  "volume_up",
  // equal to `volume_increment`
  "mute",
  "volume_decrement",
  "volume_increment"
], B = [
  // Function keys
  "f21",
  "f22",
  "f23",
  "f24",
  // Keys in pc keyboards
  "execute",
  "menu",
  "select",
  "stop",
  "again",
  "undo",
  "cut",
  "copy",
  "paste",
  "find",
  // International keys
  "international2",
  "international4",
  "international5",
  "international6",
  "international7",
  "international8",
  "international9",
  "lang3",
  "lang4",
  "lang5",
  "lang6",
  "lang7",
  "lang8",
  "lang9",
  // Japanese
  "japanese_pc_nfer",
  // PCキーボードの無変換キー
  "japanese_pc_xfer",
  // PCキーボードの変換キー
  "japanese_pc_katakana",
  // PCキーボードのかなキー
  // Others
  "keypad_equal_sign_as400",
  "locking_caps_lock",
  "locking_num_lock",
  "locking_scroll_lock",
  "alternate_erase",
  "sys_req_or_attention",
  "cancel",
  "clear",
  "prior",
  "return",
  // rarely used return (HID usage 0x9e)
  "separator",
  "out",
  "oper",
  "clear_or_again",
  "cr_sel_or_props",
  "ex_sel"
], P = [
  // Disable this key
  "vk_none",
  // Others
  "vk_consumer_brightness_down",
  // equal to `display_brightness_decrement`
  "vk_consumer_brightness_up",
  // equal to `display_brightness_increment`
  "vk_mission_control",
  // equal to `mission_control`
  "vk_launchpad",
  // equal to `launchpad`
  "vk_dashboard",
  // equal to `dashboard`
  "vk_consumer_illumination_down",
  // equal to `illumination_decrement`
  "vk_consumer_illumination_up",
  // equal to `illumination_increment`
  "vk_consumer_previous",
  // equal to `rewind`
  "vk_consumer_play",
  // equal to `play`
  "vk_consumer_next",
  // equal to `fast_forward`
  "display_brightness_decrement",
  "display_brightness_increment",
  "rewind",
  "play_or_pause",
  "fastforward",
  "apple_display_brightness_decrement",
  "apple_display_brightness_increment",
  "dashboard",
  "launchpad",
  "mission_control",
  "apple_top_case_display_brightness_decrement",
  "apple_top_case_display_brightness_increment",
  "illumination_decrement",
  "illumination_increment"
], j = {
  "⌘": "command",
  "⌥": "option",
  "⌃": "control",
  "⇧": "shift",
  "⇪": "caps_lock"
}, te = {
  "↑": "up_arrow",
  "↓": "down_arrow",
  "←": "left_arrow",
  "→": "right_arrow",
  "⇞": "page_up",
  "⇟": "page_down",
  "↖︎": "home",
  "↘︎": "end"
}, ie = {
  "⏎": "return_or_enter",
  "⎋": "escape",
  "⌫": "delete_or_backspace",
  "⌦": "delete_forward",
  "⇥": "tab",
  "␣": "spacebar",
  "-": "hyphen",
  "=": "equal_sign",
  "[": "open_bracket",
  "]": "close_bracket",
  "\\": "backslash",
  ";": "semicolon",
  "'": "quote",
  "`": "grave_accent_and_tilde",
  ",": "comma",
  ".": "period",
  "/": "slash"
}, z = {
  ...te,
  ...ie,
  "⇪": j["⇪"]
}, ye = [
  ...H,
  ...se,
  ...ae,
  ...le,
  ...ue,
  ...ce,
  ...de,
  ...fe,
  ...he,
  ...pe,
  ..._e,
  ...me,
  ...B,
  ...P
];
function v(t, e, i) {
  if (typeof t == "number")
    return `${t}`;
  if (t.length > 1 && q(t)) {
    const n = x(t);
    if ((n == null ? void 0 : n.length) === 1)
      return n[0];
    throw new Error(`Invalid key ${t}`);
  }
  if (t in z)
    return z[t];
  const o = t;
  if (!ye.includes(o))
    throw new Error(`${o} is not valid key_code`);
  if (e != null && e.includes(o))
    throw new Error(`Key ${t} cannot be used ${i || "here"}`);
  return o;
}
const be = {
  Meh: ["option", "control", "shift"],
  Hyper: ["command", "option", "control", "shift"],
  SuperHyper: ["command", "option", "control", "shift", "fn"]
}, G = {
  "⌘⇧": ["command", "shift"],
  "⌥⇧": ["option", "shift"],
  "⌃⇧": ["control", "shift"],
  "⌘⌥": ["command", "option"],
  "⌘⌃": ["command", "control"],
  "⌥⌃": ["option", "control"],
  "⌘⌥⌃": ["command", "option", "control"],
  "⌘⌥⇧": ["command", "option", "shift"],
  "⌘⌃⇧": ["command", "control", "shift"],
  "⌥⌃⇧": ["option", "control", "shift"],
  "⌘⌥⌃⇧": ["command", "option", "control", "shift"],
  ...be
};
function C(t) {
  if (!t)
    return;
  if (typeof t == "string")
    return q(t) ? x(t) : t in j ? [j[t]] : t in G ? G[t] : [t];
  if (Array.isArray(t))
    return ke(t) ? we(t) : t.map(ve);
  let e;
  "left" in t ? e = A("left", t.left) : "l" in t && (e = A("left", t.l));
  let i;
  if ("right" in t ? i = A("right", t.right) : "r" in t && (i = A("right", t.r)), !(!(e != null && e.length) && !(i != null && i.length)))
    return [...e || [], ...i || []];
}
const oe = /^(left|l|<|‹)([⌘⌥⌃⇧]*)$/, ne = /^(right|r|>|›)([⌘⌥⌃⇧]*)$/;
function $(t, e) {
  if (!(!t && !e))
    return {
      mandatory: Q(t),
      optional: Q(e)
    };
}
function Q(t) {
  if (t)
    return t === "any" ? ["any"] : C(t);
}
const ge = /* @__PURE__ */ new Set([
  "command",
  "option",
  "control",
  "shift"
]);
function q(t) {
  return oe.test(t) || ne.test(t);
}
function x(t) {
  const e = t.match(oe);
  if (e)
    return A("left", e[2]);
  const i = t.match(ne);
  if (i)
    return A("right", i[2]);
}
function ke(t) {
  return t.some(q);
}
function we(t) {
  return t.reduce(
    (e, i) => [
      ...e,
      ...q(i) ? x(i) || [] : C(i) || []
    ],
    []
  );
}
function A(t, e) {
  var i;
  if (e)
    return (i = C(e)) == null ? void 0 : i.map(
      (o) => ge.has(o) ? `${t}_${o}` : o
    );
}
function ve(t) {
  return t in j ? j[t] : t;
}
function h(t, e, i) {
  const o = v(
    t,
    B,
    "as to.key_code"
  );
  return {
    ...i,
    key_code: o,
    modifiers: e ? C(e) : void 0
  };
}
function Ce(t) {
  return h("left_command", "⌥⌃⇧", t);
}
function Me(t) {
  return h("left_option", "⌃⇧", t);
}
function Ee(t) {
  return h("fn", "⌘⌥⌃⇧", t);
}
function Ae(t) {
  return h("vk_none", void 0, t);
}
function Ke(t, e, i) {
  return {
    ...i,
    consumer_key_code: t,
    modifiers: e ? C(e) : void 0
  };
}
function Te(t, e, i) {
  return {
    ...i,
    pointing_button: t,
    modifiers: e ? C(e) : void 0
  };
}
function U(t) {
  return { shell_command: t };
}
function Se(t) {
  const e = t.match(/^"?(.*?)(.app)?"?$/);
  return U(`open -a "${(e == null ? void 0 : e[1]) || t}".app`);
}
function $e(t) {
  return U(`osascript -e '
set prev to the clipboard
set the clipboard to "${t}"
tell application "System Events"
  keystroke "v" using command down
  delay 0.1
end tell
set the clipboard to prev'`);
}
function je(t) {
  return { select_input_source: t };
}
function p(t, e = 1) {
  return { set_variable: { name: t, value: e } };
}
function Oe(t, e) {
  return { set_notification_message: { id: t, text: e } };
}
function Pe(t) {
  return { set_notification_message: { id: t, text: "" } };
}
function Ve(t) {
  return { mouse_key: t };
}
function Le(t, e = "toggle") {
  return { sticky_modifier: { [t]: e } };
}
function De(t) {
  return {
    software_function: { cg_event_double_click: { button: t } }
  };
}
function Be(t) {
  return { software_function: { set_mouse_cursor_position: t } };
}
function qe(t) {
  return {
    software_function: {
      iokit_power_management_sleep_system: { delay_milliseconds: t }
    }
  };
}
function b(t) {
  return Array.isArray(t) ? t : [t];
}
function O(t, e = 1, i) {
  return new g({ type: "variable_if", name: t, value: e, description: i });
}
function dt(t, e) {
  let i;
  if (Array.isArray(t))
    i = t.map(N);
  else if (typeof t == "string" || t instanceof RegExp)
    i = [N(t)];
  else
    return new g({
      type: "frontmost_application_if",
      description: e,
      file_paths: t.file_paths.map(N)
    });
  return new g({
    type: "frontmost_application_if",
    description: e,
    bundle_identifiers: i
  });
}
function ft(t, e) {
  return new g({
    type: "device_if",
    identifiers: b(t),
    description: e
  });
}
function ht(t, e) {
  return new g({
    type: "device_exists_if",
    identifiers: b(t),
    description: e
  });
}
function pt(t, e) {
  return new g({
    type: "keyboard_type_if",
    keyboard_types: b(t),
    description: e
  });
}
function _t(t, e) {
  return new g({
    type: "input_source_if",
    input_sources: b(t),
    description: e
  });
}
function mt(t = !0, e) {
  return new g({ type: "event_changed_if", value: t, description: e });
}
const Re = Ie({
  frontmost_application_if: "frontmost_application_unless",
  device_if: "device_unless",
  device_exists_if: "device_exists_unless",
  keyboard_type_if: "keyboard_type_unless",
  input_source_if: "input_source_unless",
  variable_if: "variable_unless",
  event_changed_if: "event_changed_unless"
});
class g {
  constructor(e) {
    this.condition = e;
  }
  /** Switch type {condition}_if to {condition}_unless, and vice versa */
  unless() {
    return new g({
      ...this.condition,
      type: Re[this.condition.type]
    });
  }
  build() {
    return { ...this.condition };
  }
}
function Ne(t) {
  return typeof t.build == "function";
}
function M(t) {
  return Ne(t) ? t.build() : t;
}
function N(t) {
  return typeof t == "string" ? t : t.toString().slice(1, -1);
}
function Ie(t) {
  return Object.keys(t).reduce((e, i) => ({ ...e, [e[i]]: i }), t);
}
const K = {};
for (let t = 0; t <= 9; t++)
  K[t] = h(t);
const Fe = "abcdefghijklmnopqrstuvwxyz".split("");
for (const t of Fe)
  K[t] = h(t), K[t.toUpperCase()] = h(t, "⇧");
const He = [
  ...Object.keys(te),
  ...Object.keys(ie)
];
for (const t of He)
  K[t] = h(t);
const xe = {
  1: "!",
  2: "@",
  3: "#",
  4: "$",
  5: "%",
  6: "^",
  7: "&",
  8: "*",
  9: "(",
  0: ")",
  "'": '"',
  "=": "+",
  ";": ":",
  ",": "<",
  ".": ">",
  "/": "?",
  "-": "_",
  "[": "{",
  "\\": "|",
  "]": "}",
  "`": "~"
};
for (const [t, e] of Object.entries(xe))
  K[e] = h(t, "⇧");
function Ue(t, e) {
  return t.split("").map((i) => {
    const o = (e == null ? void 0 : e[i]) || K[i];
    if (!o)
      throw new Error(
        `${i} is unknown. Please provide a map with { ${i}: {ToEvent} }`
      );
    return o;
  });
}
const Je = ["optionalAny", "?any", "??"];
function We(t) {
  return !t || typeof t != "string" ? !1 : Je.includes(t);
}
function ze(t) {
  return /^\?(left|l|<|‹|right|r|>|›)?([⌘⌥⌃⇧⇪]*)$/.test(t);
}
function m(t, e) {
  if (!t)
    return $(t, e);
  if (We(t))
    return $("", "any");
  if (typeof t == "string") {
    if (ze(t))
      return $(
        "",
        C(t.slice(1))
      );
    if (t.startsWith("?"))
      throw new Error(`${t} is not valid optional alias`);
  }
  return typeof t == "object" && "optional" in t ? $("", t.optional) : $(t, e);
}
function J(t, e, i) {
  if (typeof t == "object")
    return new T(t);
  const o = v(
    t,
    P,
    "for from.key_code"
  );
  return new T({
    key_code: o,
    modifiers: m(e, i)
  });
}
function yt(t, e, i) {
  return new T({
    consumer_key_code: t,
    modifiers: m(e, i)
  });
}
function bt(t, e, i) {
  return new T({
    pointing_button: t,
    modifiers: m(e, i)
  });
}
class T {
  constructor(e) {
    this.manipulator = { type: "basic", from: e };
  }
  /** The FromEvent of the Manipulator. */
  get from() {
    return this.manipulator.from;
  }
  to(e, i, o) {
    return this.addToEvent(
      typeof e == "object" ? e : h(e, i, o)
    ), this;
  }
  /** To Hyper key ⌘⌥⌃⇧ */
  toHyper(e) {
    return this.addToEvent(Ce(e)), this;
  }
  /** To Meh key ⌥⌃⇧ */
  toMeh(e) {
    return this.addToEvent(Me(e)), this;
  }
  /** To SuperHyper key ⌘⌥⌃⇧fn */
  toSuperHyper(e) {
    return this.addToEvent(Ee(e)), this;
  }
  /** To vk_none (Disable this key) */
  toNone(e) {
    return this.addToEvent(Ae(e)), this;
  }
  /** To { consumer_key_code } */
  toConsumerKey(e, i, o) {
    return this.addToEvent(Ke(e, i, o)), this;
  }
  /** Map to mouse button */
  toPointingButton(e, i, o) {
    return this.addToEvent(Te(e, i, o)), this;
  }
  /** Map to shell command */
  to$(e) {
    return this.addToEvent(U(e)), this;
  }
  /** Map to `$ open -a {app}.app` */
  toApp(e) {
    return this.addToEvent(Se(e)), this;
  }
  /** Map to paste {text} via clipboard */
  toPaste(e) {
    return this.addToEvent($e(e)), this;
  }
  /** To change the current input source */
  toInputSource(e) {
    return this.addToEvent(je(e)), this;
  }
  /** Map to setting a variable */
  toVar(e, i = 1) {
    return this.addToEvent(p(e, i)), this;
  }
  /** To set or remove (set text to '') the notification message */
  toNotificationMessage(e, i) {
    return this.addToEvent(Oe(e, i)), this;
  }
  /** To remove the notification message */
  toRemoveNotificationMessage(e) {
    return this.addToEvent(Pe(e)), this;
  }
  /** Move mouse cursor by delta */
  toMouseKey(e) {
    return this.addToEvent(Ve(e)), this;
  }
  /** Changes to a sticky modifier key */
  toStickyModifier(e, i = "toggle") {
    return this.addToEvent(Le(e, i)), this;
  }
  /** @see https://karabiner-elements.pqrs.org/docs/json/complex-modifications-manipulator-definition/to/software_function/cg_event_double_click/ */
  toCgEventDoubleClick(e) {
    return this.addToEvent(De(e)), this;
  }
  /** Set mouse cursor position */
  toMouseCursorPosition(e) {
    return this.addToEvent(Be(e)), this;
  }
  /** To causes a system sleep */
  toSleepSystem(e) {
    return this.addToEvent(qe(e)), this;
  }
  /** To type a string of keys */
  toTypeSequence(e, i) {
    return this.addToEvent(Ue(e, i)), this;
  }
  toIfAlone(e, i, o) {
    return this.pushOrCreateList(
      this.manipulator,
      "to_if_alone",
      typeof e == "object" ? e : h(e, i, o)
    ), this;
  }
  toIfHeldDown(e, i, o) {
    return this.pushOrCreateList(
      this.manipulator,
      "to_if_held_down",
      typeof e == "object" ? e : h(e, i, o)
    ), this;
  }
  toAfterKeyUp(e, i, o) {
    return this.pushOrCreateList(
      this.manipulator,
      "to_after_key_up",
      typeof e == "object" ? e : h(e, i, o)
    ), this;
  }
  toDelayedAction(e, i) {
    const o = this.manipulator.to_delayed_action || {
      to_if_invoked: [],
      to_if_canceled: []
    };
    return b(e).forEach((n) => o.to_if_invoked.push(n)), b(i).forEach((n) => o.to_if_canceled.push(n)), this.manipulator.to_delayed_action = o, this;
  }
  description(e) {
    return this.manipulator.description = e, this;
  }
  condition(...e) {
    const { conditions: i = [] } = this.manipulator;
    return this.manipulator.conditions = [...i, ...e.map(M)], this;
  }
  parameters(e) {
    return this.manipulator.parameters = { ...this.manipulator.parameters, ...e }, this;
  }
  build(e) {
    return [{ ...this.manipulator }];
  }
  addToEvent(e) {
    this.pushOrCreateList(this.manipulator, "to", e);
  }
  pushOrCreateList(e, i, o) {
    const n = e[i] || [];
    b(o).forEach((r) => n.push(r)), Object.assign(e, { [i]: n });
  }
}
function Ge(t) {
  return typeof t.build == "function";
}
function S(t, e) {
  return Ge(t) ? t.build(e) : "type" in t ? [t] : Object.entries(t).reduce(
    (o, [n, r]) => [...o, ...J(n).to(r).build(e)],
    []
  );
}
function gt(...t) {
  return (e) => {
    const i = t.map(M);
    function o(s) {
      return s.type !== "basic" ? s : {
        ...s,
        conditions: [...s.conditions || [], ...i]
      };
    }
    const r = (Array.isArray(e) ? e : S(e)).reduce(
      (s, l) => [...s, ...S(l).map(o)],
      []
    );
    return Object.assign(r, { build: () => r });
  };
}
function kt(t) {
  return (e) => ({
    build: () => (Array.isArray(t) ? t.map((o, n) => [o, n]) : Object.entries(t)).reduce(
      (o, [n, r]) => [...o, ...S(e(n, r))],
      []
    )
  });
}
function wt(t, e) {
  return (i) => ({
    build: (o) => {
      const n = m(
        t,
        e
      );
      return (Array.isArray(i) ? i : S(i)).map((s) => S(s, o)).reduce((s, l) => s.concat(l), []).map((s) => {
        var a;
        const l = Object.keys(n).reduce(
          (c, d) => {
            var u;
            if (!((u = n[d]) != null && u.length))
              return c;
            const f = /* @__PURE__ */ new Set([
              ...c[d] || [],
              ...n[d]
            ]);
            return c[d] = f.has("any") ? ["any"] : Array.from(f), c;
          },
          { ...(a = s.from) == null ? void 0 : a.modifiers }
        );
        return s.from = { ...s.from, modifiers: l }, s;
      });
    }
  });
}
function Qe(t, e, i) {
  const o = (r) => v(r, P, "for from.simultaneous"), n = new Xe({
    simultaneous: t.map(
      (r) => typeof r == "object" ? r : { key_code: o(r) }
    ),
    simultaneous_options: e
  });
  return i && n.parameters({
    "basic.simultaneous_threshold_milliseconds": i
  }), n;
}
class Xe extends T {
  constructor(e) {
    super(e);
  }
  modifiers(e, i) {
    return this.manipulator.from.modifiers = e || i ? m(e, i) : void 0, this;
  }
}
const X = {
  "double_tap.delay_milliseconds": 200
};
function vt(t, e, i, o) {
  const n = v(
    t,
    [...B, ...P],
    "for double tap"
  ), r = new Ye({ key_code: n });
  return o ? (r.delay(o), r.from.modifiers = m(
    e,
    i
  )) : i ? typeof i == "number" ? (r.delay(i), r.from.modifiers = m(
    e
  )) : r.from.modifiers = m(
    e,
    i
  ) : e && (typeof e == "number" ? r.delay(e) : r.from.modifiers = m(
    e
  )), r;
}
class Ye extends T {
  constructor(e) {
    super(e), this.singleTapEvent = void 0;
  }
  /** Set single tap which is from key by default; null to disable */
  singleTap(e) {
    return this.singleTapEvent = e, this;
  }
  /** Set the delay parameter */
  delay(e) {
    return this.delayParam = e, this;
  }
  build(e) {
    var f;
    const i = (e == null ? void 0 : e.getParameters(X)) ?? X, o = this.delayParam || i["double_tap.delay_milliseconds"], n = this.from.key_code;
    if (this.singleTapEvent === void 0) {
      this.singleTapEvent = { key_code: n };
      const u = (f = this.manipulator.from.modifiers) == null ? void 0 : f.mandatory;
      u && (this.singleTapEvent.modifiers = u.filter(
        (_) => _ !== "any"
      ));
    }
    const r = ["double-tap", n];
    this.from.modifiers && [this.from.modifiers.mandatory, this.from.modifiers.optional].map((u) => u != null && u.length ? u.join(",") : "").forEach((u) => u && r.push(u));
    const s = r.join("-"), l = O(s).build(), a = O(s).unless().build(), c = {
      ...this.manipulator,
      conditions: [...this.manipulator.conditions || [], l]
    }, d = {
      ...this.manipulator,
      to: [p(s, 1)],
      conditions: [a],
      to_delayed_action: {
        to_if_invoked: [
          ...this.singleTapEvent ? [this.singleTapEvent] : [],
          p(s, 0)
        ],
        to_if_canceled: [p(s, 0)]
      }
    };
    return d.parameters = {
      "basic.to_delayed_action_delay_milliseconds": o
    }, [c, d];
  }
}
function Ct() {
  return new Ze();
}
class Ze {
  constructor() {
    this.manipulator = {
      type: "mouse_motion_to_scroll"
    };
  }
  modifiers(e, i) {
    return this.manipulator.from = {
      modifiers: m(
        e,
        i
      )
    }, this;
  }
  condition(...e) {
    const { conditions: i = [] } = this.manipulator;
    return this.manipulator.conditions = [...i, ...e.map(M)], this;
  }
  options(e) {
    return this.manipulator.options = { ...this.manipulator.options, ...e }, this;
  }
  build(e) {
    return [{ ...this.manipulator }];
  }
}
function Mt(t, ...e) {
  return new R(t, ...e);
}
class R {
  constructor(e, ...i) {
    this.ruleDescription = e, this.manipulatorSources = [], this.allowEmptyManipulators = !1, this.conditions = i;
  }
  manipulators(e) {
    return Array.isArray(e) ? e.forEach((i) => this.manipulatorSources.push(i)) : this.manipulatorSources.push(e), this;
  }
  condition(...e) {
    return e.forEach((i) => this.conditions.push(i)), this;
  }
  description(e) {
    return this.ruleDescription = e, this;
  }
  build(e) {
    const i = {
      description: this.ruleDescription,
      manipulators: this.manipulatorSources.reduce(
        (n, r) => [...n, ...S(r, e)],
        []
      )
    };
    if (!this.allowEmptyManipulators && i.manipulators.length === 0)
      throw new Error(`"manipulators" is empty in "${i.description}"`);
    if (this.conditions.length === 0)
      return i;
    const o = this.conditions.map(M);
    return i.manipulators = i.manipulators.map(
      (n) => n.type === "basic" ? { ...n, conditions: [...n.conditions || [], ...o] } : { ...n }
    ), i;
  }
}
function et(t) {
  return typeof t.build == "function";
}
function tt(t, e) {
  return et(t) ? t.build(e) : t;
}
const F = [
  ...P,
  ...B,
  ...H
];
function it(t, e, i = 1, o = 0) {
  return new nt(t, e, i, o);
}
function ot(t, e, i, o = 1, n = 0) {
  return it(e, i, o, n).modifiers(t);
}
function Et(t, e, i = 1, o = 0) {
  return ot("Hyper", t, e, i, o);
}
class nt extends R {
  constructor(e, i, o = 1, n = 0) {
    const r = b(e).map(
      (s) => v(s, F, "as layer key")
    );
    i || (i = `layer-${r.join("-")}`), super(`Layer - ${i}`), this.onValue = o, this.offValue = n, this.replaceLayerKeyToIfAlone = !1, this.keys = r, this.varName = i, this.layerCondition = O(this.varName, this.onValue), this.condition(this.layerCondition), this.allowEmptyManipulators = !0;
  }
  modifiers(e, i) {
    return this.layerModifiers = e || i ? m(e, i) : void 0, this;
  }
  /** Config the layer key. */
  configKey(e, i = !1) {
    return this.layerKeyManipulator || (this.layerKeyManipulator = J("fn")), e(this.layerKeyManipulator), this.replaceLayerKeyToIfAlone = i, this;
  }
  build(e) {
    var n, r, s, l;
    const i = super.build(e), o = this.conditions.filter((a) => a !== this.layerCondition).map(M);
    if ((r = (n = this.layerModifiers) == null ? void 0 : n.mandatory) != null && r.length || (l = (s = this.layerModifiers) == null ? void 0 : s.optional) != null && l.length) {
      const a = Y(this.layerModifiers) === "optional";
      i.manipulators.forEach(
        (c) => this.addModifierAnyToManipulator(c, a)
      );
    }
    for (const a of this.keys)
      i.manipulators = [
        ...re(
          a,
          this.varName,
          this.onValue,
          this.offValue,
          this.layerModifiers,
          o,
          e,
          this.layerKeyManipulator,
          this.replaceLayerKeyToIfAlone
        ),
        ...i.manipulators
      ];
    return i;
  }
  // If the layer has modifiers, set manipulator modifiers to { mandatory: ['any'] }
  addModifierAnyToManipulator(e, i) {
    if (e.type === "basic") {
      if (e.from.modifiers) {
        const { mandatory: o, optional: n } = e.from.modifiers;
        if (n != null && n.length || o != null && o.length) {
          const r = Y(e.from.modifiers);
          if (r === "mandatory")
            e.from.modifiers = { mandatory: ["any"] };
          else if (r === "optional")
            e.from.modifiers = { optional: ["any"] };
          else
            throw new Error(
              "Layers with modifiers cannot have modifiers on manipulators"
            );
          return;
        }
      }
      e.from.modifiers = i ? { optional: ["any"] } : { mandatory: ["any"] };
    }
  }
}
function re(t, e, i, o, n, r, s, l, a) {
  function c(y) {
    var W;
    if (!l)
      return y;
    const E = l.build()[0], w = b(y)[0];
    if ([
      "to",
      "to_if_alone",
      "to_if_held_down",
      "to_after_key_up"
    ].forEach(
      (k) => {
        var V;
        return (V = E[k]) == null ? void 0 : V.forEach(
          (L) => w[k] = [...w[k] || [], L]
        );
      }
    ), E.to_delayed_action) {
      w.to_delayed_action = w.to_delayed_action || {
        to_if_invoked: [],
        to_if_canceled: []
      };
      for (const k of ["to_if_invoked", "to_if_canceled"])
        E.to_delayed_action[k].forEach(
          (V) => {
            var L;
            return (L = w.to_delayed_action) == null ? void 0 : L[k].push(V);
          }
        );
    }
    return a && (w.to_if_alone = (W = w.to_if_alone) == null ? void 0 : W.filter(
      (k) => !("key_code" in k && k.key_code === t)
    )), y;
  }
  const d = J({ key_code: t, modifiers: n }).toVar(e, i).toAfterKeyUp(p(e, o)).toIfAlone({ key_code: t });
  if (r != null && r.length && d.condition(...r), !s)
    return c(d.build());
  const f = [
    `layer_${t}`,
    ...n ? [JSON.stringify(n)] : [],
    ...(r || []).map((y) => JSON.stringify(y)).sort()
  ].join("_"), u = s.getCache(f);
  if (u != null && u.to && u.to_after_key_up)
    return u.to.find(
      (E) => "set_variable" in E && E.set_variable.name === e
    ) || (u.to.push(p(e, i)), u.to_after_key_up.push(p(e, o))), c(u), [];
  const _ = d.build(s);
  return s.setCache(f, _[0]), c(_);
}
function Y({
  mandatory: t,
  optional: e
}) {
  return (t == null ? void 0 : t.length) === 1 && t[0] === "any" ? "mandatory" : (e == null ? void 0 : e.length) === 1 && e[0] === "any" ? "optional" : null;
}
const Z = {
  "simlayer.threshold_milliseconds": 200
};
function At(t, e, i, o = 1, n = 0) {
  return new rt(t, e, i, o, n);
}
class rt extends R {
  constructor(e, i, o, n = 1, r = 0) {
    const s = b(e).map(
      (l) => v(l, F, "as simlayer key")
    );
    i || (i = `simlayer-${s.join("-")}`), super(`Simlayer - ${i}`), this.threshold = o, this.onValue = n, this.offValue = r, this.sharedLayerKeys = [], this.simultaneousOptions = {
      detect_key_down_uninterruptedly: !0,
      key_down_order: "strict",
      key_up_order: "strict_inverse",
      key_up_when: "any"
    }, this.layerModifiers = { optional: ["any"] }, this.keys = s, this.varName = i, this.layerCondition = O(this.varName, this.onValue), this.condition(this.layerCondition);
  }
  modifiers(e, i) {
    return this.layerModifiers = e || i ? m(e, i) : void 0, this;
  }
  /** Set simultaneous_options on the simlayer toggle manipulator */
  options(e) {
    return Object.assign(this.simultaneousOptions, e), this;
  }
  /** Enable layer with the same variable and manipulators with this simlayer */
  enableLayer(...e) {
    return e.map(
      (i) => v(i, F, "as layer key")
    ).forEach((i) => {
      if (this.keys.includes(i))
        throw new Error(`Key ${i} is already used in ${this.ruleDescription}`);
      if (this.sharedLayerKeys.includes(i))
        throw new Error(
          `Key ${i} is already used as shared layer key in  ${this.ruleDescription}`
        );
      this.sharedLayerKeys.push(i);
    }), this;
  }
  build(e) {
    const i = super.build(e), o = (e == null ? void 0 : e.getParameters(Z)) ?? Z, n = this.threshold || o["simlayer.threshold_milliseconds"], r = this.conditions.length > 1 ? this.conditions.filter((a) => a !== this.layerCondition).map(M) : void 0, s = p(this.varName, this.onValue), l = p(this.varName, this.offValue);
    i.manipulators.concat().forEach((a) => {
      var d;
      if (a.type !== "basic")
        throw new Error(
          `Unsupported manipulator type ${a.type} in simlayer ${this.ruleDescription}`
        );
      const c = (d = a.from) == null ? void 0 : d.key_code;
      if (!c)
        throw new Error(
          `Missing from.key_code in simlayer ${this.ruleDescription}`
        );
      this.layerModifiers && (a.from.modifiers = {
        ...a.from.modifiers,
        ...this.layerModifiers
      });
      for (const f of this.keys)
        i.manipulators.push({
          type: "basic",
          parameters: {
            "basic.simultaneous_threshold_milliseconds": n
          },
          to: [s, ...a.to || []],
          from: {
            simultaneous: [{ key_code: f }, { key_code: c }],
            simultaneous_options: {
              ...this.simultaneousOptions,
              to_after_key_up: [
                ...this.simultaneousOptions.to_after_key_up || [],
                l
              ]
            },
            modifiers: this.layerModifiers
          },
          conditions: r
        });
    });
    for (const a of this.sharedLayerKeys)
      i.manipulators = [
        ...re(
          a,
          this.varName,
          this.onValue,
          this.offValue,
          this.layerModifiers,
          r,
          e
        ),
        ...i.manipulators
      ];
    return i;
  }
}
const ee = {
  "duo_layer.threshold_milliseconds": 200
};
function Kt(t, e, i, o = 1, n = 0) {
  return new st(t, e, i, o, n);
}
class st extends R {
  constructor(e, i, o, n = 1, r = 0) {
    o || (o = `duo-layer-${e}-${i}`), super(`Layer - ${o}`), this.key1 = e, this.key2 = i, this.onValue = n, this.offValue = r, this.simultaneousOptions = {}, this.varName = o, this.layerCondition = O(this.varName, this.onValue), this.condition(this.layerCondition), this.allowEmptyManipulators = !0;
  }
  threshold(e) {
    return this.simultaneousThreshold = e, this;
  }
  options(e) {
    return Object.assign(this.simultaneousOptions, e), this;
  }
  build(e) {
    var c, d, f, u;
    const i = super.build(e), o = (e == null ? void 0 : e.getParameters(ee)) ?? ee, n = this.simultaneousThreshold || o["duo_layer.threshold_milliseconds"], r = this.conditions.filter((_) => _ !== this.layerCondition).map(M), s = Qe(
      [this.key1, this.key2],
      {
        ...this.simultaneousOptions,
        to_after_key_up: [
          ...this.simultaneousOptions.to_after_key_up || [],
          p(this.varName, this.offValue)
        ]
      },
      n
    ).modifiers("??").to(p(this.varName, this.onValue));
    if (r.length && s.condition(...r), !e)
      return i.manipulators = [...s.build(), ...i.manipulators], i;
    const l = [
      `duo_layer_${this.key1}_${this.key2}`,
      ...r.map((_) => JSON.stringify(_)).sort()
    ].join("_"), a = e.getCache(l);
    if (a)
      ((c = a.to) == null ? void 0 : c.find(
        (y) => "set_variable" in y && y.set_variable.name === this.varName
      )) || ((d = a.to) == null || d.push(p(this.varName, this.onValue)), (u = (f = a.from.simultaneous_options) == null ? void 0 : f.to_after_key_up) == null || u.push(
        p(this.varName, this.offValue)
      ));
    else {
      const _ = s.build(e)[0];
      e.setCache(l, _), i.manipulators = [_, ...i.manipulators];
    }
    return i;
  }
}
class at {
  constructor() {
    this.parameters = {}, this.cache = /* @__PURE__ */ new Map();
  }
  setParameters(e) {
    Object.assign(this.parameters, e);
  }
  getParameters(e) {
    const i = { ...e };
    for (const o of Object.keys(e))
      o in this.parameters && this.parameters[o] !== void 0 && Object.assign(i, { [o]: this.parameters[o] });
    return i;
  }
  getCache(e) {
    return this.cache.get(e);
  }
  setCache(e, i) {
    this.cache.set(e, i);
  }
}
const lt = {
  "basic.to_if_alone_timeout_milliseconds": 1e3,
  "basic.to_if_held_down_threshold_milliseconds": 500,
  "basic.to_delayed_action_delay_milliseconds": 500,
  "basic.simultaneous_threshold_milliseconds": 50,
  "mouse_motion_to_scroll.speed": 100
};
function ut(t, e = {}) {
  const {
    "double_tap.delay_milliseconds": i,
    "simlayer.threshold_milliseconds": o,
    ...n
  } = e, r = new at();
  r.setParameters({
    "double_tap.delay_milliseconds": i
  }), r.setParameters({
    "simlayer.threshold_milliseconds": o
  });
  const s = t.map((a) => tt(a, r)), l = {
    rules: s.filter((a) => a.manipulators.length),
    parameters: {
      ...lt,
      ...n
    }
  };
  if (l.rules.length === 0)
    throw new Error('complex_modifications "rules" is empty ');
  return l.rules.length < s.length && console.warn(`Rules with empty manipulators are ignored: 
${s.filter((a) => a.manipulators.length === 0).map((a) => "- " + a.description).join(`
`)}
`), l;
}
const D = {
  karabinerConfigDir() {
    return require("node:path").join(
      require("node:os").homedir(),
      ".config/karabiner"
    );
  },
  karabinerConfigFile() {
    return require("node:path").join(
      this.karabinerConfigDir(),
      "karabiner.json"
    );
  },
  readKarabinerConfig(t) {
    return require(t ?? this.karabinerConfigFile());
  },
  writeKarabinerConfig(t, e) {
    return require("node:fs/promises").writeFile(
      e ?? this.karabinerConfigFile(),
      t
    );
  },
  exit(t = 0) {
    process.exit(t);
  }
};
function Tt(t, e, i = {}) {
  typeof t == "string" && (t = { name: t, dryRun: t === "--dry-run" });
  const { name: o, dryRun: n } = t, r = t.karabinerJsonPath ?? D.karabinerConfigFile(), s = n ? { profiles: [{ name: o, complex_modifications: { rules: [] } }] } : D.readKarabinerConfig(r), l = s == null ? void 0 : s.profiles.find((c) => c.name === o);
  l || I(`⚠️ Profile ${o} not found in ${r}.

ℹ️ Please check the profile name in the Karabiner-Elements UI and 
    - Update the profile name at writeToProfile()
    - Create a new profile if needed
 `);
  try {
    l.complex_modifications = ut(e, i);
  } catch (c) {
    I(c);
  }
  const a = JSON.stringify(s, null, 2);
  if (n) {
    console.info(a);
    return;
  }
  D.writeKarabinerConfig(a, r).catch(I), console.log(`✓ Profile ${o} updated.`);
}
function I(t) {
  return t && console.error(typeof t == "string" ? t : t.message || t), D.exit(1);
}
export {
  g as ConditionBuilder,
  M as buildCondition,
  ut as complexModifications,
  lt as defaultComplexModificationsParameters,
  X as defaultDoubleTapParameters,
  ee as defaultDuoLayerParameters,
  Z as defaultSimlayerParameters,
  Kt as duoLayer,
  Et as hyperLayer,
  dt as ifApp,
  ft as ifDevice,
  ht as ifDeviceExists,
  mt as ifEventChanged,
  _t as ifInputSource,
  pt as ifKeyboardType,
  O as ifVar,
  Ne as isConditionBuilder,
  it as layer,
  J as map,
  yt as mapConsumerKey,
  vt as mapDoubleTap,
  bt as mapPointingButton,
  Qe as mapSimultaneous,
  ot as modifierLayer,
  Ct as mouseMotionToScroll,
  Mt as rule,
  At as simlayer,
  U as to$,
  Se as toApp,
  De as toCgEventDoubleClick,
  Ke as toConsumerKey,
  Ce as toHyper,
  je as toInputSource,
  h as toKey,
  Me as toMeh,
  Be as toMouseCursorPosition,
  Ve as toMouseKey,
  Ae as toNone,
  Oe as toNotificationMessage,
  $e as toPaste,
  Te as toPointingButton,
  Pe as toRemoveNotificationMessage,
  p as toSetVar,
  qe as toSleepSystem,
  Le as toStickyModifier,
  Ee as toSuperHyper,
  Ue as toTypeSequence,
  gt as withCondition,
  kt as withMapper,
  wt as withModifier,
  Tt as writeToProfile
};
